DEFINT A-Z
'$DYNAMIC

TYPE PalValue
    Red   AS STRING * 1
    Green AS STRING * 1
    Blue  AS STRING * 1
END TYPE

TYPE ColoursType
 High    AS INTEGER
 Norm    AS INTEGER
END TYPE

TYPE Location
  X    AS INTEGER
  Y    AS INTEGER
END TYPE

TYPE BoxLocType
 PalCursor   AS Location
 PicCursor   AS Location
END TYPE

TYPE CircleLocType
   Center AS Location
   Edge AS Location
END TYPE


TYPE LineLocType
   End1 AS Location
   End2 AS Location
END TYPE

DECLARE SUB KeysPrimTools ()
DECLARE SUB KeysSecondTools ()

DECLARE SUB UpdateAreaNotifyCircleTool ()

DECLARE SUB SavePal (Flename$)
DECLARE SUB SavePalPrompt ()

DECLARE SUB PrintFieldWithBlanking (TEXT$, X%, Y%, MaxFieldLength%)
DECLARE SUB DrawPixelInfo ()

DECLARE SUB DrawCircle ()

DECLARE SUB KeysToolExits ()
DECLARE SUB GETPAL (Entry%, Value AS ANY)

DECLARE SUB DrawColorSample ()
DECLARE SUB CircleTool ()

DECLARE SUB LoadPalPrompt ()

DECLARE SUB LoadPal (Filename$)

DECLARE SUB DrawLine ()

DECLARE SUB KeysLineEditing ()
DECLARE SUB UpdateAreaNotifyLineTool ()

DECLARE SUB KeysPictureEditingSpecial ()

DECLARE SUB KeysColorSelection ()
DECLARE SUB KeysPictureEditing ()
DECLARE SUB KeysAreaSwitch ()

DECLARE SUB TileEdMain ()
DECLARE SUB LineTool ()
DECLARE SUB RedrawTileWindow ()

DECLARE SUB InvertPalette ()

DECLARE SUB RedrawTile ()
DECLARE SUB UpdateAreaNotifyColorSelection ()
DECLARE SUB UpdateAreaNotifyPictureEditing ()

DECLARE SUB GET13 (SEG A%, BYVAL X%, BYVAL Y%)

DECLARE SUB PUT13 (SEG A%, BYVAL X%, BYVAL Y%)

DECLARE SUB PUT13TRANS (BYVAL TransColor%, SEG A%, BYVAL X%, BYVAL Y%)

DECLARE FUNCTION ARRAYPOINT13% (SEG Array%, BYVAL X%, BYVAL Y%)
DECLARE SUB ARRAYPSET13 (SEG Array%, BYVAL X%, BYVAL Y%, BYVAL ColorAttrib%)


DECLARE SUB Center (row%, colour%, TEXT$)
DECLARE SUB SetupScreen ()
DECLARE SUB InvertPicture ()
DECLARE SUB LoadTile ()
DECLARE SUB ExitProg ()
DECLARE SUB SaveTile ()


CONST Dropper = 1, Fill = 2, Drawer = 3
CONST ColorSelection = 1, PictureEditing = 2
CONST STNone = 0, STLine = 1, STCircle = 2
CONST FALSE = 0
CONST TRUE = NOT FALSE

DIM SHARED LineLoc AS LineLocType
DIM SHARED LineBox, LineFill

DIM SHARED CircleLoc AS CircleLocType
DIM SHARED CircleFill%, Radius%


DIM SHARED Colours AS ColoursType
DIM SHARED BoxLoc AS BoxLocType
DIM SHARED EditingArea, Tool, SpecialTool
DIM SHARED LCol
DIM SHARED Pic(0 TO 201)
DIM SHARED Key$
DIM SHARED ToolDone%

TileEdMain

SUB Center (row, colour, TEXT$)

LOCATE row, 20 - LEN(TEXT$) / 2
COLOR colour
PRINT TEXT$;

END SUB

SUB CircleTool
    SpecialTool = STCircle
    CircleLoc.Center = BoxLoc.PicCursor
    CircleLoc.Edge = BoxLoc.PicCursor
    Radius% = 0
    LOCATE 9, 29
    COLOR Colours.High: PRINT "RET "; : COLOR Colours.Norm: PRINT "Apply";
    LOCATE 10, 29
    COLOR Colours.High: PRINT "ESC "; : COLOR Colours.Norm: PRINT "Cancel";
    LOCATE 3, 28
    PRINT "Circle:";
    LOCATE 5, 28
    PRINT "[ ] "; : COLOR Colours.High: PRINT "F"; : COLOR Colours.Norm: PRINT "ill   ";
    LOCATE 6, 28
    COLOR Colours.High: PRINT "+"; : COLOR Colours.Norm: PRINT "Larger    ";
    LOCATE 7, 28
    COLOR Colours.High: PRINT "-"; : COLOR Colours.Norm: PRINT "Smaller";
    IF EditingArea = PictureEditing THEN
      UpdateAreaNotifyCircleTool
    END IF


    DO
      DrawCircle
      Key$ = INKEY$
      SELECT CASE EditingArea
      CASE ColorSelection
        KeysColorSelection
      CASE PictureEditing
        KeysPictureEditing
        SELECT CASE CurrentToolLoc
        CASE 0
          CircleLoc.Center = BoxLoc.PicCursor
          CircleLoc.Edge.Y = BoxLoc.PicCursor.Y
        CASE 1
          CircleLoc.Edge = BoxLoc.PicCursor
        END SELECT
      END SELECT
      KeysAreaSwitch
      SELECT CASE LCASE$(Key$)
      CASE "f"
        IF CircleFill% = TRUE THEN
          LOCATE 5, 29
          PRINT " ";
          CircleFill% = FALSE
        ELSE
          LOCATE 5, 29
          PRINT "X";
          CircleFill% = TRUE
        END IF
      CASE "i"
        IF EditingArea = PictureEditing THEN
          LCol = 255 - LCol
          DrawColorSample
        END IF

      END SELECT
      SELECT CASE Key$
      CASE "+"
        Radius% = Radius% + 1
      CASE "-"
        IF Radius% <> 0 THEN
          Radius% = Radius% - 1
        END IF
      END SELECT
      KeysToolExits
      IF ToolDone% THEN EXIT SUB
    LOOP
END SUB

SUB DrawCircle
    DIM TempFrame(0 TO 201)
    TempFrame(0) = 20
    TempFrame(1) = 20
     
    IF LCol <> 0 THEN
      VIEW SCREEN (124, 22)-(143, 41), 0
    ELSE
      VIEW SCREEN (124, 22)-(143, 41), 255
    END IF
    CIRCLE (124 + CircleLoc.Center.X, 22 + CircleLoc.Center.Y), Radius, LCol
    VIEW
    IF CircleFill% THEN
       LINE (123, 21)-STEP(21, 21), LCol, B
       PAINT (124 + CircleLoc.Center.X, 22 + CircleLoc.Center.Y), LCol
       LINE (123, 21)-STEP(21, 21), 19, B
    END IF
    GET13 TempFrame(0), 124, 22
    PUT13 Pic(0), 124, 22
    IF LCol <> 0 THEN
      PUT13TRANS 0, TempFrame(0), 124, 22
    ELSE
      PUT13TRANS 255, TempFrame(0), 124, 22
    END IF
    RedrawTileWindow
    
END SUB

SUB DrawColorSample
    DIM TempPal AS PalValue
    LINE (192, 165)-STEP(19, 23), LCol, BF
    LOCATE 20, 24
    PRINT SPACE$(16);
    LOCATE 20, 24
    PRINT STR$(LCol); ",";
    GETPAL LCol, TempPal
    PRINT STR$(ASC(TempPal.Red)); ","; STR$(ASC(TempPal.Green)); ","; STR$(ASC(TempPal.Blue));
END SUB

SUB DrawLine
    DIM TempFrame(0 TO 201)
    TempFrame(0) = 20
    TempFrame(1) = 20
   
    IF LCol <> 0 THEN
      LINE (124, 22)-(143, 41), 0, BF
    ELSE
      LINE (124, 22)-(143, 41), 255, BF
    END IF
    IF LineBox THEN
      IF LineFill THEN
        LINE (124 + LineLoc.End1.X, 22 + LineLoc.End1.Y)-(124 + LineLoc.End2.X, 22 + LineLoc.End2.Y), LCol, BF
      ELSE
        LINE (124 + LineLoc.End1.X, 22 + LineLoc.End1.Y)-(124 + LineLoc.End2.X, 22 + LineLoc.End2.Y), LCol, B
      END IF
    ELSE
      LINE (124 + LineLoc.End1.X, 22 + LineLoc.End1.Y)-(124 + LineLoc.End2.X, 22 + LineLoc.End2.Y), LCol
    END IF
    GET13 TempFrame(0), 124, 22
    PUT13 Pic(0), 124, 22
    IF LCol <> 0 THEN
      PUT13TRANS 0, TempFrame(0), 124, 22
    ELSE
      PUT13TRANS 255, TempFrame(0), 124, 22
    END IF
    RedrawTileWindow
END SUB

SUB DrawPixelInfo
    PrintFieldWithBlanking LTRIM$(STR$(BoxLoc.PicCursor.X)) + "," + STR$(BoxLoc.PicCursor.Y) + "," + STR$(ARRAYPOINT13(Pic(0), BoxLoc.PicCursor.X, BoxLoc.PicCursor.Y)), 17, 7, 11
END SUB

SUB ExitProg
LOCATE 19, 2
PRINT "Quit - Are you sure? [y/n]"
DO
 Key$ = INKEY$
 IF Key$ <> "" THEN
  SELECT CASE LCASE$(Key$)
   CASE "y"
    END
   CASE "n"
    LOCATE 19, 2
    PRINT SPACE$(30)
    EXIT DO
  END SELECT
 END IF
LOOP
END SUB

SUB InvertPalette
    FOR I = 0 TO 255
      OUT &H3C7, I
      R% = INP(&H3C9)
      g% = INP(&H3C9)
      B% = INP(&H3C9)
      OUT &H3C8, I%
      OUT &H3C9, 63 - R%
      OUT &H3C9, 63 - g%
      OUT &H3C9, 63 - B%

    NEXT I
END SUB

SUB InvertPicture
    FOR j = 0 TO 19
      FOR I = 0 TO 19
        ARRAYPSET13 Pic(0), I, j, 255 - ARRAYPOINT13(Pic(0), I, j)
      NEXT
    NEXT
END SUB

SUB KeysAreaSwitch
    SHARED Key$
    SELECT CASE LCASE$(Key$)
    CASE "c"
      EditingArea = ColorSelection
      UpdateAreaNotifyColorSelection
    CASE "e"
      EditingArea = PictureEditing
      SELECT CASE SpecialTool
      CASE STNone
        UpdateAreaNotifyPictureEditing
      CASE STLine
        UpdateAreaNotifyLineTool
      CASE STCircle
        UpdateAreaNotifyCircleTool
      END SELECT
    END SELECT

    SELECT CASE Key$
    CASE CHR$(9)
      IF EditingArea = ColorSelection THEN
        EditingArea = PictureEditing
        SELECT CASE SpecialTool
        CASE STNone
          UpdateAreaNotifyPictureEditing
        CASE STLine
          UpdateAreaNotifyLineTool
        CASE STCircle
          UpdateAreaNotifyCircleTool
        END SELECT
      ELSE
        EditingArea = ColorSelection
        UpdateAreaNotifyColorSelection
      END IF
    END SELECT
END SUB

SUB KeysColorSelection
    SELECT CASE LCASE$(Key$)
    CASE "i"
      InvertPalette
    CASE "l"
      LoadPalPrompt
    CASE "s"
      SavePalPrompt
    END SELECT
    SELECT CASE Key$
    CASE " "
      LCol = POINT(BoxLoc.PalCursor.X * 5 + 5, BoxLoc.PalCursor.Y * 5 + 155)
      DrawColorSample
    CASE CHR$(0) + "H" ' Up
      LINE (BoxLoc.PalCursor.X * 5 + 4, BoxLoc.PalCursor.Y * 5 + 154)-STEP(5, 5), 0, B
      IF BoxLoc.PalCursor.Y = 0 THEN
        BoxLoc.PalCursor.Y = 7
      ELSE
        BoxLoc.PalCursor.Y = BoxLoc.PalCursor.Y - 1
      END IF
      LINE (BoxLoc.PalCursor.X * 5 + 4, BoxLoc.PalCursor.Y * 5 + 154)-STEP(5, 5), 40, B
    CASE CHR$(0) + "P" ' Down
      LINE (BoxLoc.PalCursor.X * 5 + 4, BoxLoc.PalCursor.Y * 5 + 154)-STEP(5, 5), 0, B
      IF BoxLoc.PalCursor.Y = 7 THEN
        BoxLoc.PalCursor.Y = 0
      ELSE
        BoxLoc.PalCursor.Y = BoxLoc.PalCursor.Y + 1
      END IF
      LINE (BoxLoc.PalCursor.X * 5 + 4, BoxLoc.PalCursor.Y * 5 + 154)-STEP(5, 5), 40, B
    CASE CHR$(0) + "K" ' Left
      LINE (BoxLoc.PalCursor.X * 5 + 4, BoxLoc.PalCursor.Y * 5 + 154)-STEP(5, 5), 0, B
      IF BoxLoc.PalCursor.X = 0 THEN
        BoxLoc.PalCursor.X = 31
      ELSE
        BoxLoc.PalCursor.X = BoxLoc.PalCursor.X - 1
      END IF
      LINE (BoxLoc.PalCursor.X * 5 + 4, BoxLoc.PalCursor.Y * 5 + 154)-STEP(5, 5), 40, B
    CASE CHR$(0) + "M" ' Right
      LINE (BoxLoc.PalCursor.X * 5 + 4, BoxLoc.PalCursor.Y * 5 + 154)-STEP(5, 5), 0, B
      IF BoxLoc.PalCursor.X = 31 THEN
        BoxLoc.PalCursor.X = 0
      ELSE
        BoxLoc.PalCursor.X = BoxLoc.PalCursor.X + 1
      END IF
      LINE (BoxLoc.PalCursor.X * 5 + 4, BoxLoc.PalCursor.Y * 5 + 154)-STEP(5, 5), 40, B
    END SELECT
END SUB

SUB KeysPictureEditing
    SELECT CASE Key$
    CASE CHR$(0) + "H" ' Up
      LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 19, B
      IF BoxLoc.PicCursor.Y = 0 THEN
        BoxLoc.PicCursor.Y = 19
      ELSE
        BoxLoc.PicCursor.Y = BoxLoc.PicCursor.Y - 1
      END IF
      LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 40, B
      DrawPixelInfo
    CASE CHR$(0) + "P" ' Down
      LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 19, B
      IF BoxLoc.PicCursor.Y = 19 THEN
        BoxLoc.PicCursor.Y = 0
      ELSE
        BoxLoc.PicCursor.Y = BoxLoc.PicCursor.Y + 1
      END IF
      LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 40, B
      DrawPixelInfo
    CASE CHR$(0) + "K" ' Left
      LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 19, B
      IF BoxLoc.PicCursor.X = 0 THEN
        BoxLoc.PicCursor.X = 19
      ELSE
        BoxLoc.PicCursor.X = BoxLoc.PicCursor.X - 1
      END IF
      LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 40, B
      DrawPixelInfo
    CASE CHR$(0) + "M" ' Right
      LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 19, B
      IF BoxLoc.PicCursor.X = 19 THEN
        BoxLoc.PicCursor.X = 0
      ELSE
        BoxLoc.PicCursor.X = BoxLoc.PicCursor.X + 1
      END IF
      LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 40, B
      DrawPixelInfo
    END SELECT
END SUB

SUB KeysPictureEditingSpecial
    SELECT CASE LCASE$(Key$)
    CASE "i"
      InvertPicture
    CASE "l"
      LoadTile
    CASE "s"
      SaveTile
    END SELECT
    SELECT CASE Key$
    CASE " "
      SELECT CASE Tool
      CASE Dropper
        LCol = POINT(BoxLoc.PicCursor.X * 5 + 21, BoxLoc.PicCursor.Y * 5 + 21)
        DrawColorSample
      CASE Fill
        OCol = ARRAYPOINT13(Pic(0), BoxLoc.PicCursor.X, BoxLoc.PicCursor.Y)
        FOR j = 0 TO 19
          FOR I = 0 TO 19
            IF ARRAYPOINT13(Pic(0), I, j) = OCol THEN
              ARRAYPSET13 Pic(0), I, j, LCol
              PSET (I + 124, j + 22), LCol
              LINE (I * 5 + 21, j * 5 + 21)-STEP(3, 3), LCol, BF
            ELSE
              PRINT ARRAYPOINT13(Pic(0), I, j); I; j
              END
            END IF
          NEXT
        NEXT
      CASE Drawer
        LINE (BoxLoc.PicCursor.X * 5 + 21, BoxLoc.PicCursor.Y * 5 + 21)-STEP(3, 3), LCol, BF
        PSET (BoxLoc.PicCursor.X + 124, BoxLoc.PicCursor.Y + 22), LCol
        ARRAYPSET13 Pic(0), BoxLoc.PicCursor.X, BoxLoc.PicCursor.Y, LCol
      END SELECT
      DrawPixelInfo
    END SELECT
END SUB

SUB KeysPrimTools
    SELECT CASE LCASE$(Key$)
    CASE "d"
      Tool = Dropper
      LOCATE 5, 29
      PRINT "X"
        LOCATE 6, 29
        PRINT " "
        LOCATE 7, 29
        PRINT " "
      CASE "r"
        Tool = Fill
        LOCATE 5, 29
        PRINT " "
        LOCATE 6, 29
        PRINT "X"
        LOCATE 7, 29
        PRINT " "
      CASE "w"
       Tool = Drawer
       LOCATE 5, 29
       PRINT " "
       LOCATE 6, 29
       PRINT " "
       LOCATE 7, 29
       PRINT "X"
    END SELECT
END SUB

SUB KeysSecondTools
    SELECT CASE LCASE$(Key$)
    CASE "a"
      LineTool
      IF EditingArea = PictureEditing THEN UpdateAreaNotifyPictureEditing
    CASE "b"
      CircleTool
      IF EditingArea = PictureEditing THEN UpdateAreaNotifyPictureEditing
    END SELECT
END SUB

SUB KeysToolExits
    ToolDone% = FALSE
    SELECT CASE Key$
    CASE CHR$(13)
      GET13 Pic(0), 124, 22
      SetupScreen
      SpecialTool = STNone
      ToolDone% = TRUE
      EXIT SUB
    CASE CHR$(27)
      RedrawTile
      SetupScreen
      SpecialTool = STNone
      ToolDone% = TRUE
      EXIT SUB
    END SELECT
END SUB

SUB LineTool
    SpecialTool = STLine
    
    LineLoc.End1 = BoxLoc.PicCursor
    LineLoc.End2 = BoxLoc.PicCursor

    LOCATE 9, 29
    COLOR Colours.High: PRINT "RET "; : COLOR Colours.Norm: PRINT "Apply";
    LOCATE 10, 29
    COLOR Colours.High: PRINT "ESC "; : COLOR Colours.Norm: PRINT "Cancel";
   
    LOCATE 3, 28
    PRINT "Line: ";
    LOCATE 5, 28
    PRINT "[ ] "; : COLOR Colours.High: PRINT "B"; : COLOR Colours.Norm: PRINT "ox    ";
    LOCATE 6, 28
    PRINT "[ ] "; : COLOR Colours.High: PRINT "F"; : COLOR Colours.Norm: PRINT "ill   ";
    LOCATE 7, 28
    PRINT "        ";
    IF EditingArea = PictureEditing THEN
      UpdateAreaNotifyLineTool
    END IF
    
    DO
      DrawLine
      Key$ = INKEY$
      SELECT CASE EditingArea
      CASE ColorSelection
        KeysColorSelection
      CASE PictureEditing
        KeysPictureEditing
        SELECT CASE CurrentToolLoc
        CASE 0
          LineLoc.End1 = BoxLoc.PicCursor
        CASE 1
          LineLoc.End2 = BoxLoc.PicCursor
        END SELECT
      END SELECT
      KeysAreaSwitch
      SELECT CASE LCASE$(Key$)
      CASE "b"
        IF LineBox = TRUE THEN
          LineBox = FALSE
          LineFill = FALSE
          LOCATE 5, 28
          PRINT "[ ] "; : COLOR Colours.High: PRINT "B"; : COLOR Colours.Norm: PRINT "ox    "
          LOCATE 6, 28
          PRINT "[ ] "; : COLOR Colours.High: PRINT "F"; : COLOR Colours.Norm: PRINT "ill   "
        ELSE
          LOCATE 5, 28
          PRINT "[X] "; : COLOR Colours.High: PRINT "B"; : COLOR Colours.Norm: PRINT "ox    "
          LineBox = TRUE
        END IF
      CASE "f"
        IF LineFill = TRUE THEN
          LOCATE 6, 28
          PRINT "[ ] "; : COLOR Colours.High: PRINT "F"; : COLOR Colours.Norm: PRINT "ill   "
          LineFill = FALSE
        ELSE
          LOCATE 5, 28
          PRINT "[X] "; : COLOR Colours.High: PRINT "B"; : COLOR Colours.Norm: PRINT "ox    "
          LOCATE 6, 28
          PRINT "[X] "; : COLOR Colours.High: PRINT "F"; : COLOR Colours.Norm: PRINT "ill   "
          LineBox = TRUE
          LineFill = TRUE
        END IF
      CASE "i"
        IF EditingArea = PictureEditing THEN
          LCol = 255 - LCol
          DrawColorSample
        END IF
      CASE "m"
        IF LCol = 255 THEN
          LCol = 0
        ELSE
          LCol = LCol + 1
        END IF
          DrawColorSample
      CASE "n"
        IF LCol = 0 THEN
          LCol = 255
        ELSE
          LCol = LCol - 1
        END IF
        DrawColorSample
      CASE "s"
        LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 19, B
        SELECT CASE CurrentToolLoc
        CASE 0
          BoxLoc.PicCursor = LineLoc.End2
          CurrentToolLoc = 1
        CASE 1
           BoxLoc.PicCursor = LineLoc.End1
           CurrentToolLoc = 0
        END SELECT
        LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 40, B
      CASE "x"
        ExitProg
      END SELECT
      KeysToolExits
      IF ToolDone% THEN EXIT SUB
    LOOP
END SUB

SUB LoadPal (Filename$)
   DIM Byte AS STRING * 1
   OPEN Filename$ FOR INPUT AS 1
   CLOSE
   OPEN Filename$ FOR BINARY AS 1
   OUT &H3C8, 0
   FOR I = 0 TO 255
     FOR j = 0 TO 2
       GET #1, , Byte
       OUT &H3C9, ASC(Byte)
     NEXT
     NEXT
   CLOSE 1
END SUB

SUB LoadPalPrompt
    LOCATE 19, 2
    INPUT "Palette Name: ", Filename$
    IF "" = LTRIM$(Filename$) THEN
      LOCATE 19, 2
      PRINT SPACE$(30)
      EXIT SUB
    END IF
    LoadPal (Filename$)
    LOCATE 19, 2
    PRINT SPACE$(30)
END SUB

SUB LoadTile

LOCATE 19, 2
INPUT "Picture Name: ", Filename$
IF "" = LTRIM$(Filename$) THEN
  LOCATE 19, 2
  PRINT SPACE$(30)
  EXIT SUB
END IF
 
OPEN Filename$ FOR INPUT AS #1
CLOSE 1
OPEN Filename$ FOR BINARY AS #1
FOR I = 0 TO 201
  GET 1, , Pic(I)
NEXT I
  RedrawTile
CLOSE #1

LOCATE 19, 2
PRINT SPACE$(30)

END SUB

SUB PrintFieldWithBlanking (TEXT$, X%, Y%, MaxFieldLength%)
    LOCATE Y%, X%
    PRINT SPACE$(MaxFieldLength%);
    LOCATE Y%, X%
    PRINT TEXT$;
END SUB

SUB RedrawTile
    PUT13 Pic(0), 124, 22
    RedrawTileWindow
END SUB

SUB RedrawTileWindow
    FOR I = 0 TO 19
      FOR j = 0 TO 19
        LINE (I * 5 + 21, j * 5 + 21)-STEP(3, 3), POINT(124 + I, 22 + j), BF
      NEXT j
    NEXT I
END SUB

SUB SavePal (Flename$)
    OPEN Flename$ FOR INPUT AS 1
    CLOSE 1
    OPEN Flename$ FOR BINARY AS 1
    FOR I = 0 TO 255
      OUT &H3C7, I%
      Temp% = INP(&H3C9)
      Temp$ = CHR$(Temp%)
      PUT 1, , Temp$
      Temp% = INP(&H3C9)
      Temp$ = CHR$(Temp%)
      PUT 1, , Temp$
      Temp% = INP(&H3C9)
      Temp$ = CHR$(Temp%)
      PUT 1, , Temp$
    NEXT
CLOSE

END SUB

SUB SavePalPrompt
    LOCATE 19, 2
    INPUT "Palette Name: ", Filename$
    IF "" = LTRIM$(Filename$) THEN
      LOCATE 19, 2
      PRINT SPACE$(30)
      EXIT SUB
    END IF
    SavePal (Filename$)
    LOCATE 19, 2
    PRINT SPACE$(30)

END SUB

SUB SaveTile
    LOCATE 19, 2
    INPUT "Picture Name: ", Filename$
    IF "" = LTRIM$(Filename$) THEN
      LOCATE 19, 2
      PRINT SPACE$(30)
      EXIT SUB
    END IF
    OPEN Filename$ FOR BINARY AS #1

    FOR I = 0 TO 201
      PUT 1, , Pic(I)
    NEXT I
    CLOSE 1
    LOCATE 19, 2
    PRINT SPACE$(30)
END SUB

SUB SetupScreen
    'DO: LOOP UNTIL INKEY$ <> ""
    FOR I = 20 TO 120 STEP 5
      LINE (I, 20)-(I, 120), 19
      LINE (20, I)-(120, I), 19
    NEXT I
    'DO: LOOP UNTIL INKEY$ <> ""
    s = 5


FOR I = 0 TO 248 STEP 8
 'Don't ask me why, but (i \ 8) * 5 <> i \ 8 * 5
 'For some reason * is performed before \
 LINE ((I \ 8) * 5 + s, 155)-STEP(3, 3), I, BF
 LINE ((I \ 8) * 5 + s, 160)-STEP(3, 3), I + 1, BF
 LINE ((I \ 8) * 5 + s, 165)-STEP(3, 3), I + 2, BF
 LINE ((I \ 8) * 5 + s, 170)-STEP(3, 3), I + 3, BF
 LINE ((I \ 8) * 5 + s, 175)-STEP(3, 3), I + 4, BF
 LINE ((I \ 8) * 5 + s, 180)-STEP(3, 3), I + 5, BF
 LINE ((I \ 8) * 5 + s, 185)-STEP(3, 3), I + 6, BF
 LINE ((I \ 8) * 5 + s, 190)-STEP(3, 3), I + 7, BF
NEXT I
    DrawColorSample

'COLOR 15
Center 1, 15, "20x20 Tile Editor"

LINE (123, 21)-STEP(21, 21), 19, B
LINE (1, 10)-(319, 199), 40, B
LINE (2, 11)-(318, 198), 4, B

COLOR Colours.Norm

LOCATE 3, 28
PRINT "Tools: "
LOCATE 5, 28
PRINT "[ ] "; : COLOR Colours.High: PRINT "D"; : COLOR Colours.Norm: PRINT "ropper"
LOCATE 6, 28
PRINT "[ ] "; : COLOR Colours.High: PRINT "R"; : COLOR Colours.Norm: PRINT "eplace"
LOCATE 7, 28
PRINT "[X] Dra"; : COLOR Colours.High: PRINT "w"
COLOR Colours.Norm

LINE (27 * 8, 58)-(318, 58), 40
LINE (27 * 8 + 1, 59)-(318, 59), 4
LINE (BoxLoc.PalCursor.X * 5 + 4, BoxLoc.PalCursor.Y * 5 + 154)-STEP(5, 5), 40, B
LINE (BoxLoc.PicCursor.X * 5 + 20, BoxLoc.PicCursor.Y * 5 + 20)-STEP(5, 5), 40, B


LOCATE 9, 19
COLOR Colours.High: PRINT "C"; : COLOR Colours.Norm: PRINT "olor"
LOCATE 10, 19
COLOR Colours.High: PRINT "E"; : COLOR Colours.Norm: PRINT "dit tile"
LOCATE 12, 19
COLOR Colours.High: PRINT "TAB "; : COLOR Colours.Norm: PRINT "Toggle"
LOCATE 14, 19
PRINT "E"; : COLOR Colours.High: PRINT "x"; : COLOR Colours.Norm: PRINT "it";
LOCATE 17, 24
COLOR Colours.High: PRINT "M"; : COLOR Colours.Norm: PRINT ", "; : COLOR Colours.High: PRINT "N";
LOCATE 18, 24
COLOR Colours.Norm: PRINT "Color +, -"

   DrawPixelInfo

LOCATE 9, 29
COLOR Colours.High: PRINT "A "; : COLOR Colours.Norm: PRINT "Line   ";
LOCATE 10, 29
COLOR Colours.High: PRINT "B "; : COLOR Colours.Norm: PRINT "Circle  ";
END SUB

SUB TileEdMain
    REDIM Pic(0 TO 201)
    Colours.High = 9
    Colours.Norm = 15
    BoxLoc.PalCursor.X = 0
    BoxLoc.PalCursor.Y = 0
    BoxLoc.PicCursor.X = 0
    BoxLoc.PicCursor.Y = 0

    Pic(0) = 20
    Pic(1) = 20

    CLS
    SCREEN 13
   
    EditingArea = ColorSelection
    UpdateAreaNotifyColorSelection
    SetupScreen

    Tool = Drawer
      
    DO
      Key$ = INKEY$
      KeysAreaSwitch
      KeysSecondTools
      KeysPrimTools
      SELECT CASE LCASE$(Key$)
      CASE "m"
          IF LCol = 255 THEN
            LCol = 0
          ELSE
            LCol = LCol + 1
          END IF
          DrawColorSample
      CASE "n"
          IF LCol = 0 THEN
            LCol = 255
          ELSE
            LCol = LCol - 1
          END IF
          DrawColorSample
      CASE "x"
          ExitProg
      END SELECT
      SELECT CASE EditingArea
      CASE ColorSelection
        KeysColorSelection
      CASE PictureEditing
        KeysPictureEditing
        KeysPictureEditingSpecial
      END SELECT
    LOOP
END SUB

REM $STATIC
SUB UpdateAreaNotifyCircleTool
    LOCATE 17, 2
    PRINT "Circle: ";
    LOCATE 18, 2
    COLOR Colours.High: PRINT "I"; : COLOR Colours.Norm: PRINT "nvert          ";
END SUB

REM $DYNAMIC
SUB UpdateAreaNotifyColorSelection
    LOCATE 9, 17
    PRINT "X";
    LOCATE 10, 17
    PRINT " ";
    LOCATE 14, 26
    
    LOCATE 17, 2
    PRINT "Palette:";
LOCATE 18, 2
COLOR Colours.High: PRINT "L"; : COLOR Colours.Norm: PRINT "oad "; : COLOR Colours.High: PRINT "S";
COLOR Colours.Norm: PRINT "ave "; : COLOR Colours.High: PRINT "I"; : COLOR Colours.Norm: PRINT "nvert      ";
END SUB

SUB UpdateAreaNotifyLineTool
    LOCATE 17, 2
      PRINT "Line:   ";
    LOCATE 18, 2
    COLOR Colours.High: PRINT "S"; : COLOR Colours.Norm: PRINT "witch Endpoint "; : COLOR Colours.High: COLOR Colours.High: PRINT "I"; : COLOR Colours.Norm: PRINT "nvert";
END SUB

SUB UpdateAreaNotifyPictureEditing
LOCATE 9, 17
PRINT " "
LOCATE 10, 17
PRINT "X"

LOCATE 17, 2
PRINT "Picture:"
LOCATE 18, 2
COLOR Colours.High: PRINT "L"; : COLOR Colours.Norm: PRINT "oad "; : COLOR Colours.High: PRINT "S";
COLOR Colours.Norm: PRINT "ave "; : COLOR Colours.High: : PRINT "I"; : COLOR Colours.Norm: PRINT "nvert      ";
END SUB

